// u_70_delphi_generic_library
// 2013-02-09

// -- (C) John COLIBRI 2013
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_70_delphi_generic_library;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Splitter1: TSplitter;
    exit_: TButton;
    clear_: TButton;
    Panel3: TPanel;
    Memo1: TMemo;
    sort_person_list_: TButton;
    procedure exit_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure sort_person_list_Click(Sender: TObject);
    procedure bClick(Sender: TObject);
    procedure eClick(Sender: TObject);
    procedure dClick(Sender: TObject);
    procedure cClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
  public
  end;

var
  Form1: TForm1;

implementation
  uses Generics.Defaults, Generics.Collections
      , u_display_simple
      , u_c_person;

    {$R *.dfm}

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        Left:= 170; Top:= 110;
      end; // FormCreate

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        Memo1.Lines.Clear;
      end; // clear_Click

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // exit_Click

    // -- using

    type c_person_comparer=
             Class(tComparer<c_person>)
               function Compare(const Left, Right: c_person): Integer; Override;
             End;

    function c_person_comparer.Compare(const Left, Right: c_person): Integer;
      begin
        if Left.m_first_name< Right.m_first_name
          then Result:= -1
          else
            if Left.m_first_name> Right.m_first_name
              then Result:= 1
              else Result:= 0;
      end; // Compare

    var g_c_person_list: tList<c_person>= Nil;

    procedure TForm1.sort_person_list_Click(Sender: TObject);
      var l_i_comparer: IComparer<c_person>;
          l_c_person: c_person;
      begin
        g_c_person_list:= tList<c_person>.Create;

        g_c_person_list.Add(c_person.create_person('mike', 24));
        g_c_person_list.Add(c_person.create_person('anna', 18));
        g_c_person_list.Add(c_person.create_person('sam', 55));
        display('list');
        for l_c_person in g_c_person_list do
          display(l_c_person.ToString);

        l_i_comparer:= c_person_comparer.Create();
        g_c_person_list.Sort( l_i_comparer );


        display('');
        display('sorted list');
        for l_c_person in g_c_person_list do
          display(l_c_person.ToString);
      end; // sort_person_list_Click

    procedure TForm1.bClick(Sender: TObject);
      begin
      end; //

    procedure TForm1.cClick(Sender: TObject);
      begin
      end; //

    procedure TForm1.dClick(Sender: TObject);
      begin
      end; //

    procedure TForm1.eClick(Sender: TObject);
      begin
      end; //

    { c_person_comparer }


end.

